unit Tank1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls,
  Forms, Dialogs, ExtCtrls, Buttons, StdCtrls, DGCSnd,
  dgcslib;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Image1: TImage;
    Image3: TImage;
    SpeedButton1: TSpeedButton;
    Timer1: TTimer;
    Image4: TImage;
    ScrollBar1: TScrollBar;
    DGCSoundLib1: TDGCSoundLib;
    Som: TDGCAudio;
    SpeedButton2: TSpeedButton;
    Image5: TImage;
    Image6: TImage;
    Image2: TImage;
    Image7: TImage;
    procedure FormActivate(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation
{$R *.DFM}

{--- Constantes e variveis ---------------------------------}
const
  Stat: byte = 0;  //Liga/desliga animao
  Tiro: byte = 0;  //Tiro em andamento

var
  Buf: TBitmap; // Buffer de tela
  Tx,Ty,Cx,Vt: integer;
  Tanques,Destrd,Ammo,Explod: integer;

{--- Rotinas e Procedures de uso geral ----------------------}
procedure LimpaBuf; // Apaga o buffer de tela
var
  Chao,HBuf: HBitmap;
begin
  HBuf:= Buf.Canvas.Handle;
  Chao:= Form1.Image3.Canvas.Handle;
  Buf.Canvas.Brush.Color:= clBlack;
  Buf.Canvas.Pen.Color:= clBlack;
  Buf.Canvas.Rectangle(0,0,524,154);
  BitBlt(HBuf,0,154,131,100,Chao,0,0,SRCCOPY);
  BitBlt(HBuf,131,154,131,100,Chao,0,0,SRCCOPY);
  BitBlt(HBuf,262,154,131,100,Chao,0,0,SRCCOPY);
  BitBlt(HBuf,393,154,131,100,Chao,0,0,SRCCOPY);
end;

{--- Procedures e eventos funcionais ------------------------}

//Inicia o processamento do jogo:
procedure TForm1.FormActivate(Sender: TObject);
begin
  Buf:= TBitmap.Create;       //Cria o buffer de tela
  Buf.Width:= Image1.Width;   //Largura
  Buf.Height:= Image1.Height; //Altura
  Buf.Canvas.Font.Color:= clLime;   //Parmetros para a
  Buf.Canvas.Font.Name:= 'arial';   //impresso dos nmeros
  Buf.Canvas.Font.Style:= [fsBold];
  Buf.Canvas.Font.Height:= 32;
end;

//Inicia uma partida:
procedure TForm1.SpeedButton1Click(Sender: TObject);
begin
  Stat:= 2; SpeedButton2.Enabled:= True;
  Tanques:= 0; Destrd:= 0; Ammo:= 15;
end;

//Procedure de animao e controle do jogo:
procedure TForm1.Timer1Timer(Sender: TObject);
var
  Fogo,HBuf,Tela,Tank,Matrz,Cano,Boom: HBitmap;
  ACan,Tmb,Mosca: integer;
  Num: string;
begin
  //Define os handles das imagens
  HBuf:= Buf.Canvas.Handle;
  Tela:= Image1.Canvas.Handle;
  Tank:= Image2.Canvas.Handle;
  Cano:= Image4.Canvas.Handle;
  Fogo:= Image5.Canvas.Handle;
  //Se tiver um tanque andando...
  if Stat = 1 then begin
    //Apaga todo o buffer de tela
    LimpaBuf;
    //Verifica se a arma recuou (foi dado um tiro)
    if Tiro = 220 then Acan:= 230 else Acan:= 222;
    //Transfere o tanque para o buffer
    BitBlt(HBuf,Tx,Ty,128,64,Tank,0,0,SRCCOPY);
    //Transfere a figura do cano da arma (c/mscara)
    BitBlt(HBuf,ScrollBar1.Position,Acan,24,32,
                                    Cano,24,0,SRCAND);
    BitBlt(HBuf,ScrollBar1.Position,Acan,24,32,
                                    Cano,0,0,SRCPAINT);
    //Se tiver um tiro em andamento...
    if Tiro > 0 then begin
      //Define o comprimento da bala (1/2 pixels)
      if Tiro < 155 then Tmb:= 1 else Tmb:= 2;
      //Transfere a bala para o buffer
      BitBlt(HBuf,Cx,Tiro,1,Tmb,Cano,24,0,SRCCOPY);
      //Se o tiro foi dado agora, fogo na boca da arma
      if Tiro = 220 then begin
        //Transfere o fogo
        BitBlt(HBuf,Cx-4,216,10,13,Fogo,20,0,SRCAND);
        BitBlt(HBuf,Cx-4,216,10,13,Fogo,0,0,SRCPAINT);
      end;
      //Ajusta o prximo deslocamento do tiro
      dec(Tiro,Vt); Vt:= ((Vt + 2) div 2) + 1;
      //Se o tiro chegou no nvel do alvo...
      if Tiro < 140 then begin
        //Calcula distncia da margem esquerda do tanque
        Tiro:= 0; Mosca:= Cx-Tx;
        //Se acertou no tanque...
        if (Mosca < 120) and (Mosca > 10) then begin
          //Som da bala penetrando no metal
          Som.Sound[1].Replay;
          //Marca o tanque com o furo
          BitBlt(Tank,Mosca,51,2,2,Cano,20,0,SRCCOPY);
          //Se acertou na rea da frente, grito do homem
          if (Mosca > 95) and (Mosca < 99) then
                                         Som.Sound[2].Replay;
          //Se acertou no meio do tanque, grito do whookie
          if (Mosca > 75) and (Mosca < 79) then
                                         Som.Sound[3].Replay;
          //Se acertou na trazeira (painel de munio)
          if (Mosca > 45) and (Mosca < 48) and (Explod = 0)
            then begin
            //Explode o tanque
            Som.Sound[5].Replay;
            Explod:= 1; inc(Destrd); inc(Ammo,5);
          end;
        end;
      end;
    end;
    //Se tem uma exploso em andamento...
    if (Explod > 0) and (Explod < 8) then begin
      Boom:= Image7.Canvas.Handle;
      //Transfere o frame da exploso para o tanque
      BitBlt(Tank,0,0,128,50,Boom,0,(Explod-1)*50,SRCCOPY);
      inc(Explod);
    end;
    //Anda com o tanque dois pixels
    inc(Tx,2);
    //Se o tanque saiu da tela, recomea com outro tanque
    if Tx > 530 then Stat:= 2;
    //Imprime quantidade de tiros que ainda tem
    Buf.Canvas.Font.Color:= clLime;
    Num:= '00' + IntToStr(Ammo);
    Num:= copy(Num,length(Num)-2,3);
    Buf.Canvas.TextOut(5,0,Num);
    //Imprime quantos tanques j passaram
    Num:= '0' + IntToStr(Tanques);
    Num:= copy(Num,length(Num)-1,2);
    Buf.Canvas.TextOut(430,0,Num);
    //Imprime quantos tanques foram destrudos
    Buf.Canvas.Font.Color:= clRed;
    Num:= '0' + IntToStr(Destrd);
    Num:= copy(Num,length(Num)-1,2);
    Buf.Canvas.TextOut(480,0,Num);
    //Transfere o buffer para a tela
    BitBlt(Tela,0,0,524,254,HBuf,0,0,SRCCOPY);
    Image1.Repaint;
  end;
  //Vai ser lanado um tanque novo
  if Stat = 2 then begin
    //Apaga o buffer do tanque
    Image2.Canvas.Brush.Color:= clBlack;
    Image2.Canvas.Pen.Color:= clBlack;
    Image2.Canvas.Rectangle(0,0,128,64);
    //Transfere a imagem de um tanque intacto para o buffer
    Matrz:= Image6.Canvas.Handle;
    BitBlt(Tank,0,32,128,32,Matrz,0,0,SRCCOPY);
    //Ajusta demais parmetros
    Tx:= -128; Ty:= 90; Explod:= 0;
    inc(Tanques); Stat:= 1;
  end;
end;

//Dispara um tiro:
procedure TForm1.SpeedButton2Click(Sender: TObject);
begin
  //Se no tem um tiro em andamento...
  if Tiro = 0 then begin
    //Se tem munio para atirar...
    if Ammo = 0 then Som.Sound[4].Replay else begin
      //Som do disparo
      Som.Sound[0].Replay;
      //Cx = distncia do tiro  esquerda
      Cx:= ScrollBar1.Position+11;
      //Fator de deslocamento da bala
      Vt:= 32;
      //Menos um tiro
      dec(Ammo);
      //L vai bala...
      Tiro:= 220;
    end;
  end;
end;

//Fim, viu s como  simples e fcil?
end.
